package com.example.monnthic.monnthicmobile;

import org.web3j.crypto.RawTransaction;
import org.web3j.protocol.Web3j;
import org.web3j.protocol.Web3jFactory;
import org.web3j.protocol.core.methods.response.EthGetBalance;
import org.web3j.protocol.core.methods.response.EthGetTransactionCount;
import org.web3j.protocol.core.methods.request.Transaction;
import org.web3j.protocol.core.methods.response.EthSendTransaction;
import org.web3j.protocol.core.methods.response.TransactionReceipt;
import org.web3j.protocol.http.HttpService;
import org.web3j.protocol.core.DefaultBlockParameterName;
import org.web3j.utils.Convert;

import java.math.BigInteger;




/**
 * Created by Guillaume on 28/05/2018.
 */

public class AccessBlockchain {
    private static final String node3 = "http://5.51.59.70:1403";
    private static final String node2 = "http://93.30.148.59:1402";
    private static final String node1 = "http://93.30.148.59:1401";
    //private static String address_test = "0x5421c79d465a288c28e10aa43f9b7dff1b313c8e";
    private static String address_node3 = "0x869abc2dadd7e23c8b38f054276813a67d8131a7";
    //Web3j web3jNode2 = Web3jFactory.build(new HttpService(node2));

    public static void main(String [ ] args)
    {
        try{
            //USED FOR TEST

            /*
            Web3j web3jNode1 = Web3jFactory.build(new HttpService(node1));
            System.out.println(web3jNode1.ethCoinbase().sendAsync().get().getResult());

            EthGetTransactionCount transactionCount = web3jNode1.ethGetTransactionCount(address_test, DefaultBlockParameterName.LATEST).sendAsync().get();
            System.out.println(transactionCount);
            BigInteger nonce = transactionCount.getTransactionCount();
            System.out.println(nonce);
            */
            Web3j web3jNode1 = Web3jFactory.build(new HttpService(node1));
            System.out.println("Node 1 : ethAccounts : "+web3jNode1.ethAccounts().send().getAccounts());
            EthGetBalance ethGetBalance1 = web3jNode1.ethGetBalance("0x5421c79d465a288c28e10aa43f9b7dff1b313c8e", DefaultBlockParameterName.LATEST).sendAsync().get();


            Web3j web3jNode2 = Web3jFactory.build(new HttpService(node2));
            System.out.println("Noded 2 ethAccounts : "+web3jNode2.ethAccounts().send().getAccounts());
            EthGetBalance ethGetBalance2 = web3jNode2.ethGetBalance("0xef816528949bda3b87e19b86848fb28767156232", DefaultBlockParameterName.LATEST).sendAsync().get();

            System.out.println("Node 1 ethMining : "+web3jNode1.ethMining().send().getResult());

            System.out.println("Node 1 sync : "+web3jNode1.ethSyncing().send().getResult().toString());


            BigInteger wei1 = ethGetBalance1.getBalance();
            System.out.println("Node 1 balance is : "+wei1);

            BigInteger wei2 = ethGetBalance2.getBalance();
            System.out.println("Node 2 balance is : "+wei2);

            System.out.println("ethBlockNumber Node 1 : "+web3jNode1.ethBlockNumber().send().getResult());
            System.out.println("ethGetWork Node 1 : "+web3jNode1.ethGetWork().send().getResult());


            Web3j web3jNode3 = Web3jFactory.build(new HttpService(node3));
            System.out.println("Node 3 : ethAccounts : "+web3jNode3.ethAccounts().send().getAccounts());

            EthGetBalance ethGetBalance_n3 = web3jNode1.ethGetBalance(address_node3, DefaultBlockParameterName.LATEST).sendAsync().get();
            System.out.println("TEST node 1 wallet 3 : "+ethGetBalance_n3);

            //BigInteger test = getTheBalanceOfWallet(address);
            //System.out.println(test);

            //Web3j web3jNode1 = Web3jFactory.build(new HttpService(node1));
            //Web3j web3jNode2 = Web3jFactory.build(new HttpService(node2));
            //System.out.println("ethAccounts : "+web3jNode1.ethAccounts().send().getAccounts());
            //System.out.println("ethGasPrice : "+web3jNode1.ethGasPrice().send().getGasPrice());
            //System.out.println("ethGetWork : "+web3jNode1.ethGetWork().send().getResult());
            //System.out.println("ethBlockNumber : "+web3jNode1.ethBlockNumber().send().getResult());
            //EthGetBalance ethGetBalance = web3jNode1.ethGetBalance("0x5421c79d465a288c28e10aa43f9b7dff1b313c8e", DefaultBlockParameterName.LATEST).sendAsync().get();
           // BigInteger wei = ethGetBalance.getBalance();
            //System.out.println("wei is : "+wei);

            //System.out.println("*************************************************");
            //Web3j web3jNode1 = Web3jFactory.build(new HttpService(node1));
            //Web3j web3jNode2 = Web3jFactory.build(new HttpService(node2));
            //System.out.println("ethAccounts : "+web3jNode1.ethAccounts().send().getAccounts());
            //System.out.println("ethAccounts : "+web3jNode2.ethAccounts().send().getAccounts());
            //System.out.println("ethGasPrice : "+web3jNode2.ethGasPrice().send().getGasPrice());
            //System.out.println("ethGetWork : "+web3jNode2.ethGetWork().send().getResult());
            //System.out.println("ethBlockNumber : "+web3jNode2.ethBlockNumber().send().getResult());
            //EthGetBalance ethGetBalance2 = web3jNode2.ethGetBalance("0x0278467c617c13604b3d88b95c2257a3a8a7bc01", DefaultBlockParameterName.LATEST).sendAsync().get();
            //BigInteger wei2 = ethGetBalance2.getBalance();
            //System.out.println("wei is : "+wei2);
        }catch (Exception e){
            e.printStackTrace();
        }

    }


    //Get Balance function
    public BigInteger getTheBalanceOfWallet(String walletAddress){
        Web3j web3jNode1 = Web3jFactory.build(new HttpService(node1));
        try{
            EthGetBalance ethGetBalance = web3jNode1.ethGetBalance(walletAddress, DefaultBlockParameterName.LATEST).sendAsync().get();
            BigInteger wei = ethGetBalance.getBalance();
            return wei;
        }catch (Exception e){
            e.getMessage();
            e.printStackTrace();
        }
        return null;
    }

    //Send DbTransaction demo function
    public static boolean sendTransationTo(String addressSource, String addressDestination, BigInteger amountToSend){
        Web3j n1 = Web3jFactory.build(new HttpService(node1));
        try{
            EthGetTransactionCount transactionCount = n1.ethGetTransactionCount(addressSource, DefaultBlockParameterName.LATEST).sendAsync().get();
            String coinbase = n1.ethCoinbase().sendAsync().get().getResult();
            BigInteger nonce = transactionCount.getTransactionCount();
            BigInteger gasPrice = n1.ethGasPrice().send().getGasPrice();
            BigInteger gasLimit = gasPrice.multiply(BigInteger.valueOf(2));

            BigInteger amountEther = Convert.toWei(amountToSend.toString(), Convert.Unit.ETHER).toBigInteger();
            Transaction transaction = Transaction.createEtherTransaction(coinbase, nonce, gasPrice, gasLimit, addressDestination, amountEther);
            String txUnit = "ETHER";

            System.out.println("source : "+coinbase+"\nnonce : "+nonce+"\ngasPrice : "+gasPrice);
            System.out.println("gasLimit : "+gasLimit+"\ndestination : "+addressDestination+"\namount : "+amountEther);

            /*
            Send the transaction
             */
            //EthSendTransaction ethSendTransaction = n1.ethSendTransaction(transaction).sendAsync().get();
            //String txHash = ethSendTransaction.getTransactionHash();
            //TransactionReceipt txR = n1.ethGetTransactionReceipt(txHash).send().getResult();
            //txR.getBlockNumber();
            //insertTransaction(addressSource, addressDestination, amountToSend, txHash, txR.getBlockNumber().toString(), txUnit);

            return true;


        }catch (Exception e){
            e.getMessage();
            e.printStackTrace();
        }
        return false;
    }

    private void insertTransaction(String adS, String adD, BigInteger amTs, String txH, String blN, String txUnit){

        DbTransaction dbTrs = new DbTransaction();
    }
}
